"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonSelectBuilder = void 0;
var BelongsAccessorBase_1 = require("../decorators/base/BelongsAccessorBase");
var toPrimitive_1 = require("../functional/toPrimitive");
var DEFAULT_1 = require("../DEFAULT");
var ArrayUtil_1 = require("../utils/ArrayUtil");
var AppJoinBuilder_1 = require("./AppJoinBuilder");
/**
 * JSON Select Builder.
 *
 * @template Mine Target entity to convert to JSON data
 * @template InputT Type of input listing up the joining plans
 * @template Destination Output JSON type. Default is {@link JsonSelectBuilder.Output}
 * @author Jeongho Nam - https://github.com/samchon
 */
var JsonSelectBuilder = /** @class */ (function () {
    /* -----------------------------------------------------------
        CONSTRUCTORS
    ----------------------------------------------------------- */
    /**
     * Default Constructor.
     *
     * @param mine Target ORM class to perform the DB join
     * @param input List of relationship decorated fields with joining plan
     * @param mapper Map function to convert output type
     */
    function JsonSelectBuilder(mine, input, mapper) {
        var e_1, _a;
        this.input = input;
        this.mapper = mapper;
        this.mine_ = mine;
        this.joiner_ = new AppJoinBuilder_1.AppJoinBuilder(this.mine_);
        try {
            for (var _b = __values(Object.entries(input)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), label = _d[0], data = _d[1];
                var key = label;
                var filter = data instanceof Array ? data[1] : null;
                var value = data instanceof Array ? data[0] : data;
                if (value instanceof JsonSelectBuilder)
                    if (filter !== null)
                        this.joiner_.set(key, filter, value.joiner_);
                    else
                        this.joiner_.set(key, value.joiner_);
                else if (value === "join")
                    if (filter !== null)
                        this.joiner_.join([key, filter]);
                    else
                        this.joiner_.join(key);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    /**
     * Execute app join.
     *
     * @param data Target record(s) to be joined
     */
    JsonSelectBuilder.prototype.join = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.joiner_.execute(data)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /* -----------------------------------------------------------
        ACCESSORS
    ----------------------------------------------------------- */
    /**
     *
     * @param record
     * @param skipAppJoin
     * @returns
     */
    JsonSelectBuilder.prototype.getOne = function (record, skipAppJoin) {
        if (skipAppJoin === void 0) { skipAppJoin = false; }
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getMany([record], skipAppJoin)];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data[0]];
                }
            });
        });
    };
    /**
     *
     * @param records
     * @param skipAppJoin
     * @returns
     */
    JsonSelectBuilder.prototype.getMany = function (records, skipAppJoin) {
        if (skipAppJoin === void 0) { skipAppJoin = false; }
        return __awaiter(this, void 0, void 0, function () {
            var output;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(skipAppJoin === false)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.joiner_.execute(records)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, ArrayUtil_1.ArrayUtil.asyncMap(records, function (rec) {
                            return _this._Convert(rec);
                        })];
                    case 3:
                        output = _a.sent();
                        return [2 /*return*/, output];
                }
            });
        });
    };
    /* -----------------------------------------------------------
        CONVERTERS
    ----------------------------------------------------------- */
    JsonSelectBuilder.prototype._Convert = function (record) {
        return __awaiter(this, void 0, void 0, function () {
            var output, _loop_1, this_1, _a, _b, _c, key, value, e_2_1;
            var e_2, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        output = (0, toPrimitive_1.toPrimitive)(record);
                        _loop_1 = function (key, value) {
                            var plan, elem, data, _f, _g, _h, _j, _k, _l, data, _m, _o;
                            return __generator(this, function (_p) {
                                switch (_p.label) {
                                    case 0:
                                        if (value === undefined)
                                            return [2 /*return*/, "continue"];
                                        plan = value instanceof Array ? value[0] : value;
                                        elem = record[key];
                                        if (!(plan instanceof JsonSelectBuilder)) return [3 /*break*/, 7];
                                        return [4 /*yield*/, elem.get()];
                                    case 1:
                                        data = _p.sent();
                                        if (!(data === null)) return [3 /*break*/, 2];
                                        output[key] = null;
                                        return [3 /*break*/, 6];
                                    case 2:
                                        if (!(data instanceof Array)) return [3 /*break*/, 4];
                                        _f = output;
                                        _g = key;
                                        return [4 /*yield*/, ArrayUtil_1.ArrayUtil.asyncMap(data, function (item) {
                                                return plan._Convert(item);
                                            })];
                                    case 3:
                                        _f[_g] = _p.sent();
                                        return [3 /*break*/, 6];
                                    case 4:
                                        _h = output;
                                        _j = key;
                                        return [4 /*yield*/, plan._Convert(data)];
                                    case 5:
                                        _h[_j] = _p.sent();
                                        _p.label = 6;
                                    case 6: return [3 /*break*/, 16];
                                    case 7:
                                        if (!(plan === "recursive")) return [3 /*break*/, 9];
                                        // RECURSIVE JOINING
                                        _k = output;
                                        _l = key;
                                        return [4 /*yield*/, this_1._Convert_Recursive(key, record)];
                                    case 8:
                                        // RECURSIVE JOINING
                                        _k[_l] = _p.sent();
                                        return [3 /*break*/, 16];
                                    case 9:
                                        if (!(plan === "join")) return [3 /*break*/, 15];
                                        return [4 /*yield*/, elem.get()];
                                    case 10:
                                        data = _p.sent();
                                        if (!(data === null)) return [3 /*break*/, 11];
                                        output[key] = null;
                                        return [3 /*break*/, 14];
                                    case 11:
                                        if (!(data instanceof Array)) return [3 /*break*/, 13];
                                        _m = output;
                                        _o = key;
                                        return [4 /*yield*/, ArrayUtil_1.ArrayUtil.asyncMap(data, function (item) { return (0, toPrimitive_1.toPrimitive)(item); })];
                                    case 12:
                                        _m[_o] = _p.sent();
                                        return [3 /*break*/, 14];
                                    case 13:
                                        output[key] = (0, toPrimitive_1.toPrimitive)(data);
                                        _p.label = 14;
                                    case 14: return [3 /*break*/, 16];
                                    case 15:
                                        if (plan === DEFAULT_1.DEFAULT && elem instanceof BelongsAccessorBase_1.BelongsAccessorBase)
                                            output[key] = elem.id;
                                        _p.label = 16;
                                    case 16: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 6, 7, 8]);
                        _a = __values(Object.entries(this.input)), _b = _a.next();
                        _e.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 5];
                        _c = __read(_b.value, 2), key = _c[0], value = _c[1];
                        return [5 /*yield**/, _loop_1(key, value)];
                    case 3:
                        _e.sent();
                        _e.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_2_1 = _e.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/, this.mapper ? this.mapper(output, record) : output];
                }
            });
        });
    };
    JsonSelectBuilder.prototype._Convert_Recursive = function (key, record) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, record[key].get()];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, (function () { return __awaiter(_this, void 0, void 0, function () {
                                var output, output, _a, _b;
                                var _this = this;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            if (!(data === null)) return [3 /*break*/, 1];
                                            return [2 /*return*/, null];
                                        case 1:
                                            if (!(data instanceof Array)) return [3 /*break*/, 2];
                                            output = data.map(function (elem) { return (0, toPrimitive_1.toPrimitive)(elem); });
                                            return [2 /*return*/, ArrayUtil_1.ArrayUtil.asyncForEach(output, function (elem, i) { return __awaiter(_this, void 0, void 0, function () {
                                                    var _a, _b;
                                                    return __generator(this, function (_c) {
                                                        switch (_c.label) {
                                                            case 0:
                                                                _a = elem;
                                                                _b = key;
                                                                return [4 /*yield*/, this._Convert_Recursive(key, data[i])];
                                                            case 1: return [2 /*return*/, (_a[_b] = _c.sent())];
                                                        }
                                                    });
                                                }); })];
                                        case 2:
                                            output = (0, toPrimitive_1.toPrimitive)(data);
                                            _a = output;
                                            _b = key;
                                            return [4 /*yield*/, this._Convert_Recursive(key, data)];
                                        case 3:
                                            _a[_b] = _c.sent();
                                            return [2 /*return*/, output];
                                    }
                                });
                            }); })()];
                }
            });
        });
    };
    return JsonSelectBuilder;
}());
exports.JsonSelectBuilder = JsonSelectBuilder;
//# sourceMappingURL=JsonSelectBuilder.js.map