"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.app_join_has_many_to_many = void 0;
var Pair_1 = require("tstl/utility/Pair");
var findRepository_1 = require("../../functional/findRepository");
var getWhereArguments_1 = require("../../functional/getWhereArguments");
var ITableInfo_1 = require("../../functional/internal/ITableInfo");
var AppJoinBuilder_1 = require("../AppJoinBuilder");
var JoinQueryBuilder_1 = require("../JoinQueryBuilder");
var get_records_by_where_in_1 = require("./get_records_by_where_in");
/**
 * @internal
 */
function app_join_has_many_to_many(mine, metadata, myData, field, options) {
    return __awaiter(this, void 0, void 0, function () {
        var myTable, myDict, myIdList, router, stmt, routeList, some, partial, _a, _b, _c, _d, output, routeList_1, routeList_1_1, router_1, entry, target, tuple, e_1_1, _e, _f, entry, e_2_1, surplus;
        var _g, e_1, _h, e_2, _j;
        return __generator(this, function (_k) {
            switch (_k.label) {
                case 0:
                    // NO DATA OR MANUAL JOIN
                    if (myData.length === 0)
                        return [2 /*return*/, []];
                    else if (options.targetData)
                        return [2 /*return*/, app_join_has_many_to_many_manual(mine, metadata, myData, field, options.targetData, options.routerData)];
                    myTable = ITableInfo_1.ITableInfo.get(mine);
                    myDict = new Map(myData.map(function (elem) { return [
                        elem[myTable.primaryColumn],
                        new Pair_1.Pair(elem, []),
                    ]; }));
                    myIdList = myData.map(function (rec) { return rec[myTable.primaryColumn]; });
                    router = metadata.router();
                    stmt = (0, findRepository_1.findRepository)(router).createQueryBuilder();
                    JoinQueryBuilder_1.JoinQueryBuilder.create(stmt, router).innerJoinAndSelect(metadata.target_inverse);
                    routeList = [];
                    _k.label = 1;
                case 1:
                    if (!(myIdList.length !== 0)) return [3 /*break*/, 4];
                    some = myIdList.splice(0, AppJoinBuilder_1.AppJoinBuilder.MAX_VARIABLE_COUNT);
                    return [4 /*yield*/, (_g = stmt
                            .clone())
                            .andWhere.apply(_g, __spreadArray([], __read((0, getWhereArguments_1.getWhereArguments)(router, metadata.my_inverse, "IN", some)), false))];
                case 2:
                    partial = _k.sent();
                    if (options.filter)
                        options.filter(partial);
                    _b = (_a = routeList.push).apply;
                    _c = [routeList];
                    _d = [[]];
                    return [4 /*yield*/, partial.getMany()];
                case 3:
                    _b.apply(_a, _c.concat([__spreadArray.apply(void 0, _d.concat([__read.apply(void 0, [(_k.sent())]), false]))]));
                    return [3 /*break*/, 1];
                case 4:
                    output = [];
                    _k.label = 5;
                case 5:
                    _k.trys.push([5, 10, 11, 12]);
                    routeList_1 = __values(routeList), routeList_1_1 = routeList_1.next();
                    _k.label = 6;
                case 6:
                    if (!!routeList_1_1.done) return [3 /*break*/, 9];
                    router_1 = routeList_1_1.value;
                    entry = myDict.get(router_1[metadata.my_inverse].id);
                    if (entry === undefined)
                        return [3 /*break*/, 8];
                    return [4 /*yield*/, router_1[metadata.target_inverse].get()];
                case 7:
                    target = _k.sent();
                    tuple = {
                        router: router_1,
                        target: target,
                    };
                    entry.second.push(tuple);
                    output.push(target);
                    _k.label = 8;
                case 8:
                    routeList_1_1 = routeList_1.next();
                    return [3 /*break*/, 6];
                case 9: return [3 /*break*/, 12];
                case 10:
                    e_1_1 = _k.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 11:
                    try {
                        if (routeList_1_1 && !routeList_1_1.done && (_h = routeList_1.return)) _h.call(routeList_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 12:
                    _k.trys.push([12, 17, 18, 19]);
                    _e = __values(myDict.values()), _f = _e.next();
                    _k.label = 13;
                case 13:
                    if (!!_f.done) return [3 /*break*/, 16];
                    entry = _f.value;
                    if (metadata.comparator)
                        entry.second = entry.second.sort(metadata.comparator);
                    return [4 /*yield*/, entry.first[field].set(entry.second.map(function (elem) { return elem.target; }))];
                case 14:
                    _k.sent();
                    _k.label = 15;
                case 15:
                    _f = _e.next();
                    return [3 /*break*/, 13];
                case 16: return [3 /*break*/, 19];
                case 17:
                    e_2_1 = _k.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 19];
                case 18:
                    try {
                        if (_f && !_f.done && (_j = _e.return)) _j.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 19:
                    if (!(metadata.target() === mine)) return [3 /*break*/, 21];
                    return [4 /*yield*/, app_join_has_many_to_many(mine, metadata, output, field, options)];
                case 20:
                    surplus = _k.sent();
                    output.push.apply(output, __spreadArray([], __read(surplus), false));
                    _k.label = 21;
                case 21: return [2 /*return*/, output];
            }
        });
    });
}
exports.app_join_has_many_to_many = app_join_has_many_to_many;
function app_join_has_many_to_many_manual(mine, metadata, myData, field, targetData, routerData) {
    return __awaiter(this, void 0, void 0, function () {
        var myTable, myDict, myIdList, targetTable, targetDict, routerData_1, routerData_1_1, router, myInverse, myTuple, targetInverse, target, _a, _b, entry, accessor, e_3_1;
        var e_4, _c, e_3, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    myTable = ITableInfo_1.ITableInfo.get(mine);
                    myDict = new Map(myData.map(function (elem) { return [
                        elem[myTable.primaryColumn],
                        new Pair_1.Pair(elem, []),
                    ]; }));
                    myIdList = myData.map(function (rec) { return rec[myTable.primaryColumn]; });
                    targetTable = ITableInfo_1.ITableInfo.get(metadata.target());
                    targetDict = new Map(targetData.map(function (elem) { return [
                        elem[targetTable.primaryColumn],
                        elem,
                    ]; }));
                    if (!(routerData === null)) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, get_records_by_where_in_1.get_records_by_where_in)(metadata.router(), metadata.my_inverse, myIdList, null)];
                case 1:
                    routerData = _e.sent();
                    _e.label = 2;
                case 2:
                    try {
                        // LINK RELATIONSHIPS
                        for (routerData_1 = __values(routerData), routerData_1_1 = routerData_1.next(); !routerData_1_1.done; routerData_1_1 = routerData_1.next()) {
                            router = routerData_1_1.value;
                            myInverse = router[metadata.my_inverse];
                            myTuple = myDict.get(myInverse.id);
                            if (myTuple === undefined)
                                continue;
                            targetInverse = router[metadata.target_inverse];
                            target = targetDict.get(targetInverse.id);
                            if (target === undefined)
                                continue;
                            myTuple.second.push(target);
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (routerData_1_1 && !routerData_1_1.done && (_c = routerData_1.return)) _c.call(routerData_1);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    _e.label = 3;
                case 3:
                    _e.trys.push([3, 8, 9, 10]);
                    _a = __values(myDict.values()), _b = _a.next();
                    _e.label = 4;
                case 4:
                    if (!!_b.done) return [3 /*break*/, 7];
                    entry = _b.value;
                    accessor = entry.first[field];
                    return [4 /*yield*/, accessor.set(entry.second)];
                case 5:
                    _e.sent();
                    _e.label = 6;
                case 6:
                    _b = _a.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_3_1 = _e.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 10: 
                // RETURNS
                return [2 /*return*/, targetData];
            }
        });
    });
}
//# sourceMappingURL=app_join_has_many_to_many.js.map