"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.get_app_join_function = void 0;
var Singleton_1 = require("tstl/thread/Singleton");
var app_join_belongs_many_to_one_1 = require("./app_join_belongs_many_to_one");
var app_join_belongs_one_to_one_1 = require("./app_join_belongs_one_to_one");
var app_join_has_many_to_many_1 = require("./app_join_has_many_to_many");
var app_join_has_one_to_many_1 = require("./app_join_has_one_to_many");
var app_join_has_one_to_one_1 = require("./app_join_has_one_to_one");
/**
 * @internal
 */
function get_app_join_function(type) {
    return singleton.get()[type];
}
exports.get_app_join_function = get_app_join_function;
/**
 * @internal
 */
var singleton = new Singleton_1.Singleton(function () { return ({
    "Belongs.ManyToOne": app_join_belongs_many_to_one_1.app_join_belongs_many_to_one,
    "Belongs.External.ManyToOne": app_join_belongs_many_to_one_1.app_join_belongs_many_to_one,
    "Belongs.OneToOne": app_join_belongs_one_to_one_1.app_join_belongs_one_to_one,
    "Belongs.External.OneToOne": app_join_belongs_one_to_one_1.app_join_belongs_one_to_one,
    "Has.OneToOne": app_join_has_one_to_one_1.app_join_has_one_to_one,
    "Has.External.OneToOne": app_join_has_one_to_one_1.app_join_has_one_to_one,
    "Has.OneToMany": app_join_has_one_to_many_1.app_join_has_one_to_many,
    "Has.External.OneToMany": app_join_has_one_to_many_1.app_join_has_one_to_many,
    "Has.ManyToMany": app_join_has_many_to_many_1.app_join_has_many_to_many,
}); });
//# sourceMappingURL=get_app_join_function.js.map