"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Belongs = void 0;
var BelongsExternalManyToOne_1 = require("./external/BelongsExternalManyToOne");
var BelongsExternalOneToOne_1 = require("./external/BelongsExternalOneToOne");
var BelongsManyToOne_1 = require("./internal/BelongsManyToOne");
var BelongsOneToOne_1 = require("./internal/BelongsOneToOne");
/**
 * Decorators for the "belongs" relationship.
 *
 * `Belongs` is a module containing decorators who can represent the "belongs" relationship.
 *
 * @author Jeongho Nam - https://github.com/samchon
 */
var Belongs;
(function (Belongs) {
    Belongs.ManyToOne = BelongsManyToOne_1.BelongsManyToOne;
    Belongs.OneToOne = BelongsOneToOne_1.BelongsOneToOne;
    var External;
    (function (External) {
        External.ManyToOne = BelongsExternalManyToOne_1.BelongsExternalManyToOne;
        External.OneToOne = BelongsExternalOneToOne_1.BelongsExternalOneToOne;
    })(External = Belongs.External || (Belongs.External = {}));
})(Belongs = exports.Belongs || (exports.Belongs = {}));
//# sourceMappingURL=Belongs.js.map