import * as orm from "typeorm";
import { CapsuleNullable } from "../../typings/CapsuleNullable";
import { Creator } from "../../typings/Creator";
import { PrimaryColumnType } from "../../typings/PrimaryColumnType";
import { StringColumnType } from "../../typings/StringColumnType";
import { BelongsAccessorBase } from "../base/BelongsAccessorBase";
import { HasExternalOneToMany } from "./HasExternalOneToMany";
export declare type BelongsExternalManyToOne<Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalManyToOne.IOptions<Type>> = {}> = BelongsExternalManyToOne.Accessor<Target, Type, Options>;
export declare function BelongsExternalManyToOne<Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalManyToOne.IOptions<Type>>>(targetGen: Creator.Generator<Target>, type: Type, myField: string, options?: Options): PropertyDecorator;
export declare function BelongsExternalManyToOne<Mine extends object, Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalManyToOne.IOptions<Type>>>(targetGen: Creator.Generator<Target>, inverse: (target: Target) => HasExternalOneToMany<Mine>, type: Type, myField: string, options?: Options): PropertyDecorator;
export declare namespace BelongsExternalManyToOne {
    interface IOptions<Type extends PrimaryColumnType> extends Required<Omit<orm.ColumnOptions, "primary">> {
        index: boolean;
        unsigned: Type extends StringColumnType ? never : boolean;
        length: number;
    }
    class Accessor<Target extends object, Type extends PrimaryColumnType, Options extends Partial<IOptions<Type>>> extends BelongsAccessorBase<Target, Type, Options> {
        private readonly metadata_;
        private readonly mine_;
        private singleton_;
        private constructor();
        get id(): CapsuleNullable<PrimaryColumnType.ValueType<Type>, Options>;
        set id(value: CapsuleNullable<PrimaryColumnType.ValueType<Type>, Options>);
        set(obj: CapsuleNullable<Target, Options>): Promise<void>;
        reload(): Promise<CapsuleNullable<Target, Options>>;
        get(): Promise<CapsuleNullable<Target, Options>>;
        private _Get;
        private get_null_error_message;
    }
}
