import { Singleton } from "tstl/thread/Singleton";
import * as orm from "typeorm";
import { CapsuleNullable } from "../../typings/CapsuleNullable";
import { Creator } from "../../typings/Creator";
import { PrimaryColumnType } from "../../typings/PrimaryColumnType";
import { StringColumnType } from "../../typings/StringColumnType";
import { BelongsAccessorBase } from "../base/BelongsAccessorBase";
import { HasExternalOneToOne } from "./HasExternalOneToOne";
export declare type BelongsExternalOneToOne<Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalOneToOne.IOptions<Type>> = {}> = BelongsExternalOneToOne.Accessor<Target, Type, Options>;
export declare function BelongsExternalOneToOne<Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalOneToOne.IOptions<Type>>>(targetGen: Creator.Generator<Target>, type: Type, myField: string, options?: Options): PropertyDecorator;
export declare function BelongsExternalOneToOne<Mine extends object, Target extends object, Type extends PrimaryColumnType, Options extends Partial<BelongsExternalOneToOne.IOptions<Type>>>(targetGen: Creator.Generator<Target>, inverse: (target: Target) => HasExternalOneToOne<Mine>, type: Type, myField: string, options?: Options): PropertyDecorator;
export declare namespace BelongsExternalOneToOne {
    interface IMetadata<T extends object> {
        type: "Belongs.External.OneToOne";
        target: () => Creator<T>;
        inverse: string | null;
        property: string;
        foreign_key_field: string;
        target_priamary_field: Singleton<string>;
        nullable: boolean;
    }
    interface IOptions<Type extends PrimaryColumnType> extends Required<Omit<orm.RelationOptions, "primary" | "eager" | "lazy">> {
        index: boolean;
        primary: boolean;
        unique: boolean;
        unsigned: Type extends StringColumnType ? never : boolean;
        length: number;
    }
    class Accessor<Target extends object, Type extends PrimaryColumnType, Options extends Partial<IOptions<Type>>> extends BelongsAccessorBase<Target, Type, Options> {
        private readonly metadata_;
        private readonly mine_;
        private singleton_;
        private constructor();
        get id(): CapsuleNullable<PrimaryColumnType.ValueType<Type>, Options>;
        set id(value: CapsuleNullable<PrimaryColumnType.ValueType<Type>, Options>);
        set(obj: CapsuleNullable<Target, Options>): Promise<void>;
        reload(): Promise<CapsuleNullable<Target, Options>>;
        get(): Promise<CapsuleNullable<Target, Options>>;
        private _Get;
        private get_null_error_message;
    }
}
