"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWhereArguments = void 0;
var crypto = __importStar(require("crypto"));
var InvalidArgument_1 = require("tstl/exception/InvalidArgument");
var BelongsAccessorBase_1 = require("../decorators/base/BelongsAccessorBase");
var findRepository_1 = require("./findRepository");
var get_column_name_tuple_1 = require("./internal/get_column_name_tuple");
function getWhereArguments(creator, fieldLike) {
    var _a, _b;
    var rest = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        rest[_i - 2] = arguments[_i];
    }
    var escaper = typeof fieldLike === "string"
        ? function (column) { return column; }
        : function (column) { return fieldLike[1](column); };
    var _c = __read((0, get_column_name_tuple_1.get_column_name_tuple)(creator, typeof fieldLike === "string" ? fieldLike : fieldLike[0]), 2), alias = _c[0], column = _c[1];
    var left = escaper(alias ? "".concat(alias, ".").concat(column) : column);
    // MOST OPERATORS
    if (rest.length <= 2) {
        // SPECIALIZE OPERATOR AND PARAMETER
        var _d = __read((function () {
            var _a = __read(rest.length === 1 ? ["=", rest[0]] : [rest[0], rest[1]], 2), operator = _a[0], param = _a[1];
            return [
                operator,
                typeof param === "function"
                    ? param
                    : _Decompose_parameter(param),
            ];
        })(), 2), operator = _d[0], param = _d[1];
        // IS NULL || IS-NOT-NULL
        if (param === null) {
            if (operator === "=")
                return ["".concat(left, " IS NULL")];
            else if (operator === "!=" || operator === "<>")
                return ["".concat(left, " IS NOT NULL")];
            else
                throw new InvalidArgument_1.InvalidArgument("Error on ".concat(creator.name, ".getColumn(): unable to bind null value for the ").concat(operator, " operator."));
        }
        // RETURNS RAW QUERY
        if (typeof param === "function")
            return ["".concat(left, " ").concat(operator, " ").concat(param()), {}];
        // RETURNS WITH BINDING
        var uuid = crypto.randomBytes(64).toString("hex");
        var binding = operator === "IN" || operator === "NOT IN"
            ? "(:...".concat(uuid, ")")
            : ":".concat(uuid);
        return ["".concat(left, " ").concat(operator, " ").concat(binding), (_a = {}, _a[uuid] = param, _a)];
    }
    // BETWEEN OPERATOR
    var from = crypto.randomBytes(64).toString("hex");
    var to = crypto.randomBytes(64).toString("hex");
    var minimum = _Decompose_entity(rest[1]);
    var maximum = _Decompose_entity(rest[2]);
    return [
        "".concat(left, " BETWEEN ").concat(typeof minimum === "function" ? minimum() : ":".concat(from), " AND ").concat(typeof maximum === "function" ? maximum() : ":".concat(to)),
        (_b = {},
            _b[from] = minimum,
            _b[to] = maximum,
            _b),
    ];
}
exports.getWhereArguments = getWhereArguments;
function _Decompose_parameter(param) {
    if (param instanceof Array && param.length !== 0)
        return param.map(function (p) { return _Decompose_entity(p); });
    else
        return _Decompose_entity(param);
}
function _Decompose_entity(param) {
    var _a;
    if (typeof param !== "function" &&
        param instanceof Object &&
        !(param instanceof Date)) {
        if (param instanceof BelongsAccessorBase_1.BelongsAccessorBase)
            param = param.id;
        else {
            var pkField = (_a = (0, findRepository_1.findRepository)(param.constructor).metadata.primaryColumns[0]) === null || _a === void 0 ? void 0 : _a.propertyName;
            if (pkField !== undefined)
                param = param[pkField];
        }
    }
    return param;
}
//# sourceMappingURL=getWhereArguments.js.map