"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ITableInfo = void 0;
var DomainError_1 = require("tstl/exception/DomainError");
var MapUtil_1 = require("../../utils/MapUtil");
var findRepository_1 = require("../findRepository");
var ITableInfo;
(function (ITableInfo) {
    var DICT = new WeakMap();
    function get(creator) {
        return MapUtil_1.MapUtil.take(DICT, creator, function () {
            var _a, _b;
            var metadata = (0, findRepository_1.findRepository)(creator).metadata;
            if (metadata.primaryColumns.length !== 1)
                throw new DomainError_1.DomainError("Error on ITableInfo.get(): number of primary columns of \"".concat(creator.name, "\" table is not one."));
            var primary = metadata.primaryColumns[0];
            return {
                name: metadata.tableName,
                primaryColumn: primary.propertyName,
                uuid: primary.generationStrategy === "uuid",
                incremental: primary.generationStrategy === "increment",
                createDateColumn: (_a = metadata.createDateColumn) === null || _a === void 0 ? void 0 : _a.propertyName,
                updateDateColumn: (_b = metadata.updateDateColumn) === null || _b === void 0 ? void 0 : _b.propertyName,
            };
        });
    }
    ITableInfo.get = get;
})(ITableInfo = exports.ITableInfo || (exports.ITableInfo = {}));
//# sourceMappingURL=ITableInfo.js.map