"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SnakeCaseStrategy = void 0;
var pluralize_1 = __importDefault(require("pluralize"));
var typeorm_1 = require("typeorm");
var SnakeCaseStrategy = /** @class */ (function (_super) {
    __extends(SnakeCaseStrategy, _super);
    function SnakeCaseStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SnakeCaseStrategy.prototype.tableName = function (targetName, userSpecifiedName) {
        if (userSpecifiedName === undefined)
            userSpecifiedName = (0, pluralize_1.default)(pascal_to_snake(targetName));
        return userSpecifiedName;
    };
    SnakeCaseStrategy.prototype.columnName = function (propertyName, customName, embeddedPrefixes) {
        if (!customName)
            customName = propertyName;
        return __spreadArray(__spreadArray([], __read(embeddedPrefixes), false), [customName], false).map(function (str) { return pascal_to_snake(str); })
            .join("_");
    };
    SnakeCaseStrategy.prototype.relationName = function (propertyName) {
        return pascal_to_snake(propertyName);
    };
    SnakeCaseStrategy.prototype.prefixTableName = function (prefix, tableName) {
        return "".concat(prefix, "_").concat(tableName);
    };
    return SnakeCaseStrategy;
}(typeorm_1.DefaultNamingStrategy));
exports.SnakeCaseStrategy = SnakeCaseStrategy;
function pascal_to_snake(name) {
    var elements = name.split(/(?=[A-Z])/);
    var emended = elements.length > 1 && is_underscore_prefixed(elements[0]) === true
        ? __spreadArray([elements[0] + elements[1]], __read(elements.slice(2)), false) : elements;
    return emended.map(function (str) { return str.toLowerCase(); }).join("_");
}
function is_underscore_prefixed(str) {
    var e_1, _a;
    try {
        for (var str_1 = __values(str), str_1_1 = str_1.next(); !str_1_1.done; str_1_1 = str_1.next()) {
            var ch = str_1_1.value;
            if (ch !== "_")
                return false;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (str_1_1 && !str_1_1.done && (_a = str_1.return)) _a.call(str_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return true;
}
//# sourceMappingURL=SnakeCaseStrategy.js.map