export declare namespace ArrayUtil {
    function at<T>(array: T[], index: number): T;
    function asyncFilter<Input>(elements: readonly Input[], pred: (elem: Input, index: number, array: readonly Input[]) => Promise<boolean>): Promise<Input[]>;
    function asyncForEach<Input>(elements: readonly Input[], closure: (elem: Input, index: number, array: readonly Input[]) => Promise<any>): Promise<void>;
    function asyncMap<Input, Output>(elements: readonly Input[], closure: (elem: Input, index: number, array: readonly Input[]) => Promise<Output>): Promise<Output[]>;
    function asyncRepeat<T>(count: number, closure: (index: number) => Promise<T>): Promise<T[]>;
    function has<T>(elements: readonly T[], pred: (elem: T) => boolean): boolean;
    function repeat<T>(count: number, closure: (index: number) => T): T[];
    function last<T>(array: T[]): T;
    function flat<T>(matrix: T[][]): T[];
}
