"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapUtil = void 0;
var MapUtil;
(function (MapUtil) {
    function associate(elements, keyGen, valueGen) {
        var e_1, _a;
        var output = new Map();
        try {
            for (var elements_1 = __values(elements), elements_1_1 = elements_1.next(); !elements_1_1.done; elements_1_1 = elements_1.next()) {
                var elem = elements_1_1.value;
                output.set(keyGen(elem), valueGen(elem));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (elements_1_1 && !elements_1_1.done && (_a = elements_1.return)) _a.call(elements_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return output;
    }
    MapUtil.associate = associate;
    function associate_with_array(elements, keyGen, valueGen) {
        var e_2, _a;
        var dict = new Map();
        try {
            for (var elements_2 = __values(elements), elements_2_1 = elements_2.next(); !elements_2_1.done; elements_2_1 = elements_2.next()) {
                var elem = elements_2_1.value;
                var key = keyGen(elem);
                var array = take(dict, key, function () { return []; });
                array.push(valueGen(elem));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (elements_2_1 && !elements_2_1.done && (_a = elements_2.return)) _a.call(elements_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return dict;
    }
    MapUtil.associate_with_array = associate_with_array;
    function take(dict, key, generator, recollector) {
        var oldbie = dict.get(key);
        if (oldbie !== undefined) {
            if (recollector)
                recollector(oldbie);
            return oldbie;
        }
        var value = generator();
        dict.set(key, value);
        return value;
    }
    MapUtil.take = take;
})(MapUtil = exports.MapUtil || (exports.MapUtil = {}));
//# sourceMappingURL=MapUtil.js.map